import math

import TSM
reload(TSM)
from TSM import *

speed = 0.1
rotspeed = 0.2
stop = ("stop", (0, 0))
go = ("go", (speed, 0))         # forward velocity = speed (in meters/s)
goFast = ("goFast", (speed*2, 0))  
left = ("left", (0, rotspeed))     # rotational velocity = speed (in radians/s)
right = ("right", (0, -rotspeed))
leftFast = ("left", (0, rotspeed*2))  
rightFast = ("right", (0, -rotspeed*2))

######################################################################
#   State Machine Brain
######################################################################
def setup():
    # behavior is a state machine with sensor inputs and motor outputs
    robot.behavior = yourTSMHere
    robot.behavior.reset()
    
def step():
    if robot.behavior.done():
        doAction(stop)
    else:
        doAction(robot.behavior.step(collectSensors()))

def collectSensors():
    return [sonarDistances(), pose()]

def doAction(action):
    (name, (transVel, rotVel)) = action
    print name
    motorOutput(transVel, rotVel)

######################################################################
#   Utilities
######################################################################

def poseDist(pose1, pose2):
    (x1,y1,th1) = pose1
    (x2,y2,th2) = pose2
    return math.sqrt((x1 - x2)**2 + (y1 - y2)**2)

def within(a, b, eps):
    return abs(a - b) < eps

def nearAngle(a1,a2,eps):
   return abs(fixAnglePlusMinusPi(a1-a2)) < eps

# Put betwen minus pi and pi
def fixAnglePlusMinusPi(a):
   if a > math.pi:
      return fixAnglePlusMinusPi(a - 2.0* math.pi)
   elif a < -math.pi:
      return fixAnglePlusMinusPi(a + 2.0*math.pi)
   else:
      return a
